import "cn-next/es/input/style";
import _Input from "cn-next/es/input";
import "cn-next/es/icon/style";
import _Icon from "cn-next/es/icon";
import "cn-next/es/checkbox/style";
import _Checkbox from "cn-next/es/checkbox";
import _extends from "@babel/runtime/helpers/extends";
import { Fragment } from "react";

/* eslint-disable @typescript-eslint/no-unsafe-argument */

/* eslint-disable @typescript-eslint/no-unsafe-call */

/* eslint-disable @typescript-eslint/ban-ts-comment */

/* eslint-disable @typescript-eslint/no-unsafe-member-access */

/* eslint-disable @typescript-eslint/no-unsafe-assignment */

/* eslint-disable @typescript-eslint/no-unsafe-return */
import * as React from 'react';
import "./style/index.scss";
import { useControlValue } from "./hooks";
import { debounce, isDef, isFunction, isString } from "./util";
export default function ListFilter(props) {
  var _value$length, _allValue$length, _filterValue$length, _filterList$length;

  var list = props.list,
      labelKey = props.labelKey,
      valueKey = props.valueKey,
      className = props.className,
      style = props.style,
      searchStyle = props.searchStyle,
      searchTransform = props.searchTransform,
      column = props.column;

  var _React$useState = React.useState(''),
      search = _React$useState[0],
      setSearch = _React$useState[1];

  var onChangeSearch = debounce(function (val) {
    setSearch(val);
  }, 500, false);
  var allValue = React.useMemo(function () {
    return getAllValue(list, valueKey);
  }, [list]);
  var filterList = React.useMemo(function () {
    return getFilterList(list, isFunction(searchTransform) ? searchTransform(search) : search, labelKey);
  }, [list, search, labelKey]); // console.log(allValue, 'allValue');

  var _useControlValue = useControlValue(props, {
    defaultValuePropName: 'defaultValue',
    valuePropName: 'value',
    changePropName: 'onChange',
    defaultValue: []
  }),
      value = _useControlValue[0],
      setValue = _useControlValue[1]; // console.log(value, 'value');


  var filterValue = React.useMemo(function () {
    return (filterList === null || filterList === void 0 ? void 0 : filterList.filter(function (item) {
      return value.includes(item.id);
    })) || [];
  }, [filterList, value]);

  var _useControlValue2 = useControlValue(props, {
    defaultValuePropName: 'defaultOpenKeys',
    valuePropName: 'openKeys',
    changePropName: 'onChangeOpenKeys',
    defaultValue: []
  }),
      openKeys = _useControlValue2[0],
      setOpenKeys = _useControlValue2[1];

  var valueMap = React.useMemo(function () {
    return Array.isArray(value) ? value.reduce(function (ret, next) {
      var _extends2;

      return _extends({}, ret, (_extends2 = {}, _extends2[next] = true, _extends2));
    }, {}) : {};
  }, [value]);
  var openKeysMap = React.useMemo(function () {
    return Array.isArray(openKeys) ? openKeys.reduce(function (ret, next) {
      var _extends3;

      return _extends({}, ret, (_extends3 = {}, _extends3[next] = true, _extends3));
    }, {}) : {};
  }, [openKeys]);

  var _onChange = function onChange(changeValue, checked) {
    var ret = Array.isArray(value) ? [].concat(value) : [];

    if (checked && !valueMap[changeValue]) {
      ret.push(changeValue);
      setValue(ret);
    } else if (!checked && valueMap[changeValue]) {
      var valueSet = new Set(ret);
      valueSet["delete"](changeValue);
      setValue(Array.from(valueSet));
    }
  };

  var onChangeOpenKeys = function onChangeOpenKeys(changeOpenKey, isOpen) {
    var ret = Array.isArray(openKeys) ? [].concat(openKeys) : [];

    if (isOpen && !openKeysMap[changeOpenKey]) {
      ret.push(changeOpenKey);
      setOpenKeys(ret);
    } else if (!isOpen && openKeysMap[changeOpenKey]) {
      var valueSet = new Set(ret);
      valueSet["delete"](changeOpenKey);
      setOpenKeys(Array.from(valueSet));
    }
  };

  var onCheckAll = function onCheckAll(checked) {
    setValue(checked ? [].concat(allValue) : []);
  };

  var onCheckAllFilterValue = function onCheckAllFilterValue(checked) {
    var filterValueList = filterList === null || filterList === void 0 ? void 0 : filterList.map(function (item) {
      return item.id;
    });

    if (checked) {
      setValue([].concat(value, filterValueList));
    } else {
      setValue(allValue.filter(function (item) {
        return filterList.includes(item);
      }));
    }
  }; // @ts-ignore


  function renderList(list, level) {
    if (level === void 0) {
      level = 1;
    }

    return Array.isArray(list) ? list.map(function (item, index) {
      var _item, _item2, _item3, _item3$children, _item4, _valueMap$item, _item7, _item9, _ref, _ref2, _column$code, _item10, _item11;

      if (item === void 0) {
        item = {
          children: []
        };
      }

      if (index === void 0) {
        index = 1;
      }

      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
        className: "cn-list-filter-item " + (valueMap[(_item = item) === null || _item === void 0 ? void 0 : _item[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']] ? 'cn-list-filter-selected' : ''),
        key: (_item2 = item) === null || _item2 === void 0 ? void 0 : _item2[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']
      }, ((_item3 = item) === null || _item3 === void 0 ? void 0 : (_item3$children = _item3.children) === null || _item3$children === void 0 ? void 0 : _item3$children.length) > 0 ? /*#__PURE__*/React.createElement(CaretRightIcon, {
        className: openKeysMap[(_item4 = item) === null || _item4 === void 0 ? void 0 : _item4[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']] && 'cn-list-filter-opened',
        onClick: function onClick() {
          var _item5, _item6;

          onChangeOpenKeys((_item5 = item) === null || _item5 === void 0 ? void 0 : _item5[valueKey !== null && valueKey !== void 0 ? valueKey : 'value'], !openKeysMap[(_item6 = item) === null || _item6 === void 0 ? void 0 : _item6[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']]);
        }
      }) : null, /*#__PURE__*/React.createElement(_Checkbox, {
        checked: (_valueMap$item = valueMap[(_item7 = item) === null || _item7 === void 0 ? void 0 : _item7[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']]) !== null && _valueMap$item !== void 0 ? _valueMap$item : false,
        onChange: function onChange(checked) {
          var _item8;

          _onChange((_item8 = item) === null || _item8 === void 0 ? void 0 : _item8[valueKey !== null && valueKey !== void 0 ? valueKey : 'value'], checked);
        },
        className: "cn-list-filter-checkbox"
      }), (column === null || column === void 0 ? void 0 : column.render) instanceof Function ? column.render((_item9 = item) === null || _item9 === void 0 ? void 0 : _item9[(_ref = (_ref2 = (_column$code = column.code) !== null && _column$code !== void 0 ? _column$code : column.key) !== null && _ref2 !== void 0 ? _ref2 : labelKey) !== null && _ref !== void 0 ? _ref : ''], item, level === 1 ? index : -1) : isUndefOrNullString(item[labelKey !== null && labelKey !== void 0 ? labelKey : 'label']) ? '空' : item[labelKey !== null && labelKey !== void 0 ? labelKey : 'label']), openKeysMap[(_item10 = item) === null || _item10 === void 0 ? void 0 : _item10[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']] && /*#__PURE__*/React.createElement("div", {
        style: {
          marginLeft: level * 16
        },
        className: "cn-list-filter-list"
      }, renderList((_item11 = item) === null || _item11 === void 0 ? void 0 : _item11.children, level + 1)));
    }) : null;
  }

  return /*#__PURE__*/React.createElement("div", {
    style: style,
    className: "cn-list-filter" + (className ? " " + (className !== null && className !== void 0 ? className : '') : '')
  }, /*#__PURE__*/React.createElement(_Input, {
    innerBefore: /*#__PURE__*/React.createElement(_Icon, {
      type: "search",
      style: {
        margin: 4
      }
    }),
    placeholder: "search",
    className: "cn-list-filter-search",
    onChange: onChangeSearch,
    style: searchStyle
  }), /*#__PURE__*/React.createElement("div", {
    className: "cn-list-filter-list cn-list-filter-wrapper"
  }, !search ? /*#__PURE__*/React.createElement("div", {
    className: "cn-list-filter-item " + (allValue.length === (value === null || value === void 0 ? void 0 : value.length) ? 'cn-list-filter-selected' : '')
  }, /*#__PURE__*/React.createElement(_Checkbox, {
    checked: allValue.length === (value === null || value === void 0 ? void 0 : value.length),
    className: "cn-list-filter-checkbox",
    onChange: onCheckAll
  }), "\u5168\u9009(", (_value$length = value === null || value === void 0 ? void 0 : value.length) !== null && _value$length !== void 0 ? _value$length : 0, "/", (_allValue$length = allValue === null || allValue === void 0 ? void 0 : allValue.length) !== null && _allValue$length !== void 0 ? _allValue$length : 0, ")") : filterList !== null && filterList !== void 0 && filterList.length ? /*#__PURE__*/React.createElement("div", {
    className: "cn-list-filter-item " + (allValue.length === (filterList === null || filterList === void 0 ? void 0 : filterList.length) ? 'cn-list-filter-selected' : '')
  }, /*#__PURE__*/React.createElement(_Checkbox, {
    checked: filterValue.length === (filterList === null || filterList === void 0 ? void 0 : filterList.length),
    className: "cn-list-filter-checkbox",
    onChange: onCheckAllFilterValue
  }), "\u5168\u9009\u641C\u7D22\u9879\u76EE(", (_filterValue$length = filterValue === null || filterValue === void 0 ? void 0 : filterValue.length) !== null && _filterValue$length !== void 0 ? _filterValue$length : 0, "/", (_filterList$length = filterList === null || filterList === void 0 ? void 0 : filterList.length) !== null && _filterList$length !== void 0 ? _filterList$length : 0, ")") : null, renderList(filterList, 1)));
}

function dfs(list, handlerCallback) {
  Array.isArray(list) && list.forEach(function (item) {
    var _item$children;

    handlerCallback instanceof Function && handlerCallback(item);

    if ((item === null || item === void 0 ? void 0 : (_item$children = item.children) === null || _item$children === void 0 ? void 0 : _item$children.length) > 0) {
      dfs(item === null || item === void 0 ? void 0 : item.children, handlerCallback);
    }
  });
} // 是否为叶子结点


function isLeafNode(item) {
  var _item$children2;

  return !((item === null || item === void 0 ? void 0 : (_item$children2 = item.children) === null || _item$children2 === void 0 ? void 0 : _item$children2.length) > 0);
}

function dfsHouxu(list, handlerCallback, level) {
  if (level === void 0) {
    level = 1;
  }

  Array.isArray(list) && list.forEach(function (item) {
    var _item$children3;

    if ((item === null || item === void 0 ? void 0 : (_item$children3 = item.children) === null || _item$children3 === void 0 ? void 0 : _item$children3.length) > 0) {
      dfsHouxu(item === null || item === void 0 ? void 0 : item.children, handlerCallback, level + 1);
    }

    handlerCallback instanceof Function && handlerCallback(item, level);
  });
}

function getAllValue(list, valueKey) {
  var allValue = [];
  dfs(list, function (item) {
    if ((valueKey !== null && valueKey !== void 0 ? valueKey : 'value') in item) {
      allValue.push(item === null || item === void 0 ? void 0 : item[valueKey !== null && valueKey !== void 0 ? valueKey : 'value']);
    }
  });
  return allValue;
}

function getNewNode(labelKey) {
  var _ref3;

  return _ref3 = {}, _ref3[labelKey !== null && labelKey !== void 0 ? labelKey : 'label'] = '', _ref3.value = '', _ref3.children = [], _ref3;
}

function getFilterList(list, search, labelKey) {
  if (labelKey === void 0) {
    labelKey = 'label';
  }

  if (search === '') {
    return list;
  }

  var nowNodes = null;
  var nowNodeLevel = -1;
  var nowTree = null;
  var nowTreeLevel = -1;
  dfsHouxu(list, function (item, level) {
    if (nowNodeLevel === -1) {
      // 初始化
      nowNodeLevel = level;
      nowNodes = getNewNode(labelKey);
    }

    if (level < nowNodeLevel) {
      var _nowNodes, _nowNodes$children;

      // 增加了一层，就做一层统计
      if (nowNodes && ((_nowNodes = nowNodes) === null || _nowNodes === void 0 ? void 0 : (_nowNodes$children = _nowNodes.children) === null || _nowNodes$children === void 0 ? void 0 : _nowNodes$children.length) > 0) {
        var _nowNodes2;

        // 当前有节点, 则新建
        var newTempNode = _extends({}, item, {
          children: (_nowNodes2 = nowNodes) === null || _nowNodes2 === void 0 ? void 0 : _nowNodes2.children
        });

        nowNodes = _extends({}, getNewNode(labelKey), {
          children: [newTempNode]
        });
      }

      if (level === nowTreeLevel && nowTree && nowNodes) {
        // 重新返回
        nowTree.children = nowTree.children.concat(nowNodes.children);
        nowNodes = nowTree;
      }
    } else if (level > nowNodeLevel) {
      var _labelKey, _labelKey2;

      // 开始深入下去
      // 记录当前start
      nowTreeLevel = nowNodeLevel;
      nowTree = nowNodes; // 记录当前end

      nowNodeLevel = level;
      nowNodes = getNewNode(labelKey);

      if (item && isString(item[(_labelKey = labelKey) !== null && _labelKey !== void 0 ? _labelKey : 'label']) && item[(_labelKey2 = labelKey) !== null && _labelKey2 !== void 0 ? _labelKey2 : 'label'].includes(search)) {
        var _nowNodes3, _nowNodes3$children, _nowNodes3$children$p;

        (_nowNodes3 = nowNodes) === null || _nowNodes3 === void 0 ? void 0 : (_nowNodes3$children = _nowNodes3.children) === null || _nowNodes3$children === void 0 ? void 0 : (_nowNodes3$children$p = _nowNodes3$children.push) === null || _nowNodes3$children$p === void 0 ? void 0 : _nowNodes3$children$p.call(_nowNodes3$children, item);
      }
    } else if (level === nowNodeLevel) {
      var _labelKey3, _labelKey4;

      // 平层，开始compare
      // @ts-ignore
      if (item && isString(item[(_labelKey3 = labelKey) !== null && _labelKey3 !== void 0 ? _labelKey3 : 'label']) && item[(_labelKey4 = labelKey) !== null && _labelKey4 !== void 0 ? _labelKey4 : 'label'].includes(search)) {
        var _nowNodes4, _nowNodes4$children, _nowNodes4$children$p;

        (_nowNodes4 = nowNodes) === null || _nowNodes4 === void 0 ? void 0 : (_nowNodes4$children = _nowNodes4.children) === null || _nowNodes4$children === void 0 ? void 0 : (_nowNodes4$children$p = _nowNodes4$children.push) === null || _nowNodes4$children$p === void 0 ? void 0 : _nowNodes4$children$p.call(_nowNodes4$children, item);
      }
    } // 同步层次


    nowNodeLevel = level;
  }); // @ts-ignore

  return nowNodes && nowNodes.children ? nowNodes.children : list;
}

function CaretRightIcon(props) {
  return /*#__PURE__*/React.createElement("svg", _extends({
    focusable: "false",
    preserveAspectRatio: "xMidYMid meet",
    fill: "currentColor",
    width: "16",
    height: "16",
    viewBox: "0 0 32 32"
  }, props), /*#__PURE__*/React.createElement("path", {
    d: "M12 8L22 16 12 24z"
  }));
}

function isUndefOrNullString(val) {
  return !isDef(val) || isString(val) && val.replace(/\s/g, '') === '';
}