"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _visualengine = require("@ali/visualengine");

var _visualengineUtils = _interopRequireDefault(require("@ali/visualengine-utils"));

var _vuStyleProperty = _interopRequireDefault(require("@ali/vu-style-property"));

var _vuUuidProperty = _interopRequireDefault(require("@ali/vu-uuid-property"));

var _vuEventsProperty = _interopRequireDefault(require("@ali/vu-events-property"));

var _const = require("../const");

var _logo = _interopRequireDefault(require("./logo"));

var TextSetter = _visualengineUtils["default"].TextSetter,
    JsonSetter = _visualengineUtils["default"].JsonSetter; // 原型配置请参考：https://lark.alipay.com/vision/docs/prototype

var _default = _visualengine.Bundle.createPrototype({
  title: _const.componentName,
  componentName: _const.componentName,
  category: '自定义',
  icon: _logo["default"],
  docUrl: '',
  configure: [{
    name: 'jsonProps',
    title: '参数',
    display: 'block',
    tip: {
      content: 'JSON格式传入所有参数,可绑定数据源动态修改参数值'
    },
    supportVariable: true,
    initialValue: {},
    setter: /*#__PURE__*/_react["default"].createElement(JsonSetter, {
      label: "\u7F16\u8F91\u53C2\u6570"
    })
  }, {
    name: 'content',
    title: '子元素内容',
    display: 'block',
    tip: {
      content: '可绑定数据源使用JSX'
    },
    supportVariable: true,
    initialValue: '',
    setter: /*#__PURE__*/_react["default"].createElement(TextSetter, null)
  }, (0, _vuStyleProperty["default"])(), {
    type: 'group',
    title: '高级',
    display: 'accordion',
    items: [(0, _vuUuidProperty["default"])(_const.componentName)].concat((0, _vuEventsProperty["default"])([{
      name: 'onClick',
      title: 'onClick 点击按钮',
      initialValue: "/**\n * button onClick\n */\nfunction onClick(){\n  console.log('onClick from builder');\n}"
    }]))
  }]
});

exports["default"] = _default;
module.exports = exports.default;
module.exports.default = exports.default;