"use strict";

exports.__esModule = true;
exports.useControlValue = useControlValue;
exports.useSecond = useSecond;
exports.useUnitValue = useUnitValue;
exports.useUpdate = void 0;

var _react = require("react");

var _util = require("./util");

/* eslint-disable @typescript-eslint/no-unsafe-argument */

/* eslint-disable @typescript-eslint/ban-ts-comment */

/* eslint-disable @typescript-eslint/no-unsafe-member-access */

/* eslint-disable @typescript-eslint/no-unsafe-return */

/* eslint-disable @typescript-eslint/no-unsafe-assignment */
function useSecond(callback, deps) {
  var hasBeSecond = (0, _react.useRef)(false);
  (0, _react.useMemo)(function () {
    if (hasBeSecond.current) {
      callback instanceof Function && callback();
    } else {
      hasBeSecond.current = true;
    }
  }, [].concat(deps));
}

function useUnitValue(props, opts) {
  var _props$valuePropName;

  var _opts$defaultValuePro = opts.defaultValuePropName,
      defaultValuePropName = _opts$defaultValuePro === void 0 ? [] : _opts$defaultValuePro,
      _opts$valuePropName = opts.valuePropName,
      valuePropName = _opts$valuePropName === void 0 ? 'value' : _opts$valuePropName;

  var _useState = (0, _react.useState)((_props$valuePropName = props[valuePropName]) !== null && _props$valuePropName !== void 0 ? _props$valuePropName : defaultValuePropName),
      data = _useState[0],
      setData = _useState[1];

  useSecond(function () {
    setData(props[valuePropName]);
  }, [props[valuePropName]]);
  return [data, setData];
}

function useControlValue(props, opts) {
  var _ref, _props$valuePropName2;

  var _opts$defaultValuePro2 = opts.defaultValuePropName,
      defaultValuePropName = _opts$defaultValuePro2 === void 0 ? 'defaultValue' : _opts$defaultValuePro2,
      _opts$valuePropName2 = opts.valuePropName,
      valuePropName = _opts$valuePropName2 === void 0 ? 'value' : _opts$valuePropName2,
      _opts$changePropName = opts.changePropName,
      changePropName = _opts$changePropName === void 0 ? 'onChange' : _opts$changePropName,
      defaultValue = opts.defaultValue;

  var _useState2 = (0, _react.useState)((_ref = (_props$valuePropName2 = props === null || props === void 0 ? void 0 : props[valuePropName]) !== null && _props$valuePropName2 !== void 0 ? _props$valuePropName2 : props === null || props === void 0 ? void 0 : props[defaultValuePropName]) !== null && _ref !== void 0 ? _ref : defaultValue),
      data = _useState2[0],
      setData = _useState2[1];

  var setHandler = (0, _react.useCallback)(function () {
    var finalChange = (0, _util.getValueByPath)(props, changePropName.split('.'), null);

    if ((0, _util.isFunction)(finalChange)) {
      // @ts-ignore
      finalChange.apply(void 0, arguments);
    } // @ts-ignore


    !(valuePropName in (props || {})) && setData.apply(void 0, arguments);
  }, [props, valuePropName, changePropName]);
  useSecond(function () {
    setData(props[valuePropName]);
  }, [props === null || props === void 0 ? void 0 : props[valuePropName]]); // @ts-ignore

  return [data, setHandler];
}

var useUpdate = function useUpdate() {
  var _useState3 = (0, _react.useState)({}),
      setState = _useState3[1];

  return (0, _react.useCallback)(function () {
    return setState({});
  }, []);
};

exports.useUpdate = useUpdate;